//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    3
#property indicator_color1     LimeGreen
#property indicator_color2     DeepPink
#property indicator_color3     Gold
#property indicator_width1     2
#property indicator_width2     2
#property indicator_style3     STYLE_DASH

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    Price           = 0;
extern double ItPeriod        = 20;
extern int    MaMethod        = MODE_EMA;
extern int    LevelBars       = 300;
extern double LevelFactor     = 0.283;

extern string _               = "alerts settings";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double Upval[];
double Dnval[];
double ItLev[];
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
      IndicatorBuffers(4);
      SetIndexBuffer(0,Upval); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,Dnval); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,ItLev);
      SetIndexBuffer(3,trend);
      
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
      IndicatorShortName(timeFrameToString(timeFrame)+"  ITrend ");
   return(0);
}

//
//
//
//
//

int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Upval[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
    
      for (i=limit-1; i>=0; i--)
      {  
         double ma = iMA(NULL,0,1,0,MaMethod,Price,i);
         Upval[i]  = ma        - iMA(NULL,0,ItPeriod,0,MaMethod,Price,i);
         Dnval[i]  = - (Low[i] - iMA(NULL,0,ItPeriod,0,MaMethod,Price,i)
                     +  High[i]- iMA(NULL,0,ItPeriod,0,MaMethod,Price,i));
                     
         double hi = MathMax(Upval[ArrayMaximum(Upval,LevelBars,i)],Dnval[ArrayMaximum(Dnval,LevelBars,i)]);
         ItLev[i]  = hi*LevelFactor; 
         trend[i]  = trend[i+1]; 
         
	      if (Upval[i] > ItLev[i]) trend[i]= 1; 
	      if (Dnval[i] > ItLev[i]) trend[i]=-1;
       }  
   
       SetLevelValue(0,ItLev[0]);
       manageAlerts();
     return(0);
    }

    //
    //
    //
    //
    //
  
    limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    for (i=limit;i>=0; i--)
    {
       int y = iBarShift(NULL,timeFrame,Time[i]);
            Upval[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,ItPeriod,MaMethod,LevelBars,LevelFactor,0,y);
            Dnval[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,ItPeriod,MaMethod,LevelBars,LevelFactor,1,y);
            ItLev[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,ItPeriod,MaMethod,LevelBars,LevelFactor,2,y);
            trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,ItPeriod,MaMethod,LevelBars,LevelFactor,3,y);
            
            
    }   
    manageAlerts();
return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+"  Itrend ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"  Itrend "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}


